'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _join = require('./join');

var _join2 = _interopRequireDefault(_join);

var _toMoment2 = require('./toMoment');

var _toMoment3 = _interopRequireDefault(_toMoment2);

var _NavBar = require('./NavBar');

var _NavBar2 = _interopRequireDefault(_NavBar);

var _reactFlex = require('react-flex');

var _reactStyleNormalizer = require('react-style-normalizer');

var _reactStyleNormalizer2 = _interopRequireDefault(_reactStyleNormalizer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TRANSITION_DURATION = '0.4s';

var TransitionView = function (_Component) {
  _inherits(TransitionView, _Component);

  function TransitionView(props) {
    _classCallCheck(this, TransitionView);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(TransitionView).call(this, props));

    var child = _react2.default.Children.toArray(_this.props.children)[0];
    var childProps = child.props;

    _this.state = {
      rendered: false,
      viewDate: childProps.defaultViewDate
    };
    return _this;
  }

  _createClass(TransitionView, [{
    key: 'toMoment',
    value: function toMoment(value, props) {
      props = props || this.props;

      return (0, _toMoment3.default)(value, {
        locale: props.locale,
        dateFormat: props.dateFormat
      });
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.setState({
        viewMoment: this.getNextState().viewMoment
      });
    }
  }, {
    key: 'getNextState',
    value: function getNextState(childProps) {

      childProps = childProps || this.prepareChildProps();

      return {
        viewMoment: childProps.viewMoment,
        date: childProps.date || childProps.moment,
        activeDate: childProps.activeDate,
        range: childProps.range
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setState({
        rendered: true
      });
    }
  }, {
    key: 'prepareChildProps',
    value: function prepareChildProps(child, extraProps) {
      if (this.view) {
        return this.view.p;
      }

      child = child || _react2.default.Children.toArray(this.props.children)[0];

      var prepareProps = child.type && child.type.prototype && child.type.prototype.prepareProps;

      return prepareProps.call({
        toMoment: this.toMoment
      }, (0, _objectAssign2.default)({}, child.props, extraProps), this.state);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var props = this.props;

      var children = _react2.default.Children.toArray(props.children);

      var child = this.child = children[0];

      var childProps = this.prepareChildProps(child, {
        viewMoment: this.state.viewMoment
      });

      this.nextState = this.getNextState(childProps);

      var newProps = {
        ref: function ref(v) {
          return _this2.view = v;
        },

        viewMoment: this.state.viewMoment,

        onViewDateChange: this.onViewDateChange,
        theme: props.theme || child.props.theme,
        navigation: false,
        className: (0, _join2.default)(child.props.className, 'react-date-picker__center')
      };

      if (this.state.transition) {
        this.transitionDurationStyle = (0, _reactStyleNormalizer2.default)({ transitionDuration: props.transitionDuration || TRANSITION_DURATION });

        newProps.style = (0, _objectAssign2.default)({}, child.props.style, this.transitionDurationStyle), newProps.onTransitionEnd = this.onTransitionEnd;

        newProps.className = (0, _join2.default)(newProps.className, 'react-date-picker--transition', 'react-date-picker--transition-' + (this.state.transition == -1 ? 'left' : 'right'));
      }

      var clone = _react2.default.cloneElement(child, newProps);

      return _react2.default.createElement(
        _reactFlex.Flex,
        _extends({
          column: true,
          wrap: false,
          alignItems: 'stretch'
        }, props, {
          className: (0, _join2.default)(props.className, 'react-date-picker__transition-month-view', props.theme && 'react-date-picker__transition-month-view--theme-' + props.theme)
        }),
        _react2.default.createElement(_NavBar2.default, {
          minDate: childProps.minDate,
          maxDate: childProps.maxDate,
          secondary: true,
          viewMoment: this.state.viewMoment,
          onViewDateChange: this.onViewDateChange
        }),
        _react2.default.createElement(
          _reactFlex.Flex,
          { row: true, style: { position: 'relative' } },
          this.renderAt(-1),
          clone,
          this.renderAt(1)
        )
      );
    }
  }, {
    key: 'onViewDateChange',
    value: function onViewDateChange(dateString, _ref) {
      var _this3 = this;

      var dateMoment = _ref.dateMoment;


      if ((0, _moment2.default)(dateMoment).startOf('month').isSame((0, _moment2.default)(this.state.viewMoment).startOf('month'))) {
        return;
      }

      setTimeout(function () {
        //in order to allow this.view.p to update

        _this3.nextViewMoment = dateMoment;

        var newState = {};

        if (dateMoment.isAfter(_this3.state.viewMoment)) {
          newState.transition = -1;
        } else {
          newState.transition = 1;
        }

        _this3.setState(newState);
      });
    }
  }, {
    key: 'onTransitionEnd',
    value: function onTransitionEnd() {
      var _this4 = this;

      if (!this.nextViewMoment) {
        return;
      }

      this.setState({
        viewMoment: this.nextViewMoment,
        transition: 0
      }, function () {
        _this4.view && _this4.view.focus && _this4.view.focus();
      });
    }
  }, {
    key: 'renderAt',
    value: function renderAt(index) {
      if (!this.state.rendered) {
        return null;
      }

      var viewMoment = this.view.getViewMoment();
      var viewSize = this.view.getViewSize ? this.view.getViewSize() : 1;

      var childProps = this.child.props;

      var newProps = {

        viewMoment: (0, _moment2.default)(this.state.viewMoment).add(viewSize * index, 'month'),

        date: this.nextState.date,
        range: this.nextState.range,
        activeDate: this.nextState.activeDate,

        key: index,
        navigation: false,
        className: (0, _join2.default)(childProps.className, 'react-date-picker__' + (index == -1 ? 'prev' : 'next'))

      };

      if (this.state.transition && this.state.transition != index) {
        newProps.style = (0, _objectAssign2.default)({}, childProps.style, this.transitionDurationStyle), newProps.className = (0, _join2.default)(newProps.className, 'react-date-picker--transition', 'react-date-picker--transition-' + (this.state.transition == -1 ? 'left' : 'right'));
      }

      return _react2.default.cloneElement(this.child, newProps);
    }
  }]);

  return TransitionView;
}(_reactClass2.default);

exports.default = TransitionView;


TransitionView.defaultProps = {
  theme: 'default'
};